#! /usr/bin/env bash

set -o errexit

image="$1"
[ -n "$image" ] || { echo "Usage: $0 <astra|ufo|ccpi|ccpi-remote|tomo|tomo-remote|imageX> [tag]"; exit 1; }

tag=latest
[ -n "$2" ] && tag="$2"


#container=cuda-working-container-15
container=$(buildah from localhost/${image}:${tag})

#buildah run $container bash
#exit

buildah config --env CIL_VERSION=19.10 --env HOME=/ccpi/data --env LD_LIBRARY_PATH="/ccpi/repos/CCPi-Regularisation-Toolkit/src/Core:/ccpi/repos/CCPi-Framework/src/Core" $container
buildah copy $container setup /root/setup
buildah run $container bash /root/setup/repos.sh "all" "/root/setup"

#buildah commit --format docker $container ccpi:${tag}
echo "buildah commit --format docker $container ${image}:${tag}"
