user="$(id -un)"
home="/home/$user"
port="$(($(id -u)%100 + 100))"
ssh_port="${port}22"
web_port="${port}80"


image="$1"
#tag="latest"
tag="22.04"

[ -n "$image" ] || image="localhost/tomo-remote:$tag"		# tomo-remote:latest tomo-remote:devel tomo-remote:evelina (also ccpi, ufo, tomo)

options="--cap-add SYS_ADMIN --cap-add=SYS_PTRACE --hooks-dir /usr/share/containers/oci/hooks.d"

volumes="-v $home/ccpi/build/setup:/root/setup -v $home/ccpi/data:/ccpi/data -v $home/ccpi/repos:/ccpi/repos -v /mnt/fast:/mnt/fast"
[ -d /mnt/fast/$user ] && volumes="$volumes -v /mnt/fast/$user:/ccpi/data/fast"

echo "Image: $image, Ports: $ssh_port, $web_port"
